﻿using MedicalDatabaseContracts.Models;

namespace MedicalDatabaseContracts
{
    public interface IStorage<T> where T : AbstractModel
    {
        T? Get(int id, out long elapsedMilliseconds);
        T? Get(int id);
        List<T> GetAll(out long elapsedMilliseconds);
        List<T> GetAll();
        void Insert(T item, out long elapsedMilliseconds);
        void Insert(T item);
        void Update(T item, out long elapsedMilliseconds);
        void Update(T item);
        void Delete(int id, out long elapsedMilliseconds);
        void Delete(int id);
    }
}
